import{s as be,n as we,o as $e}from"../chunks/scheduler.db6b1edd.js";import{S as ge,i as xe,g as i,s as a,r as j,A as Te,h as o,f as s,c as r,j as ce,u as M,x as l,k as ve,y as _e,a as n,v as H,d as L,t as A,w as E}from"../chunks/index.ef84021a.js";import{H as te,E as Ce}from"../chunks/EditOnGithub.f0365ffe.js";function qe(se){let u,I,y,S,h,W,p,ne='The <a href="https://github.com/huggingface/dataset-viewer" rel="nofollow">dataset viewer</a> has two main components that work together to return queries about a dataset instantly:',z,m,ae="<li>a user-facing web API for exploring and returning information about a dataset</li> <li>a server runs the queries ahead of time and caches them in a database</li>",U,d,re="While most of the documentation is focused on the web API, the server is crucial because it performs all the time-consuming preprocessing and stores the results so the web API can retrieve and serve them to the user. This saves a user time because instead of generating the response every time it gets requested, the dataset viewer can return the preprocessed results instantly from the cache.",J,f,ie="There are three elements that keep the server running: the job queue, workers, and the cache.",O,c,F,v,oe="The job queue is a list of jobs stored in a Mongo database that should be completed by the workers. The jobs are practically identical to the endpoints the user uses; only the server runs the jobs ahead of time, and the user gets the results when they use the endpoint.",G,b,le="There are three jobs:",R,w,ue='<li><code>/splits</code> corresponds to the <code>/splits</code> endpoint. It refreshes a dataset and then returns that dataset’s splits and configurations. For every split in the dataset, it’ll create a new job.</li> <li><code>/first-rows</code> corresponds to the <code>/first-rows</code> endpoint. It gets the first 100 rows and columns of a dataset split.</li> <li><code>/parquet</code> corresponds to the <code>/parquet</code> endpoint. It downloads the whole dataset, converts it to <a href="https://parquet.apache.org/" rel="nofollow">parquet</a> and publishes the parquet files to the Hub.</li>',Y,$,he="You might’ve noticed the <code>/rows</code> and <code>/search</code> endpoints don’t have a job in the queue. The responses from these endpoints are generated on demand.",B,g,D,x,pe="Workers are responsible for executing the jobs in the queue. They complete the actual preprocessing requests, such as getting a list of splits and configurations. The workers can be controlled by configurable environment variables, like the minimum or the maximum number of rows returned by a worker or the maximum number of jobs to start per dataset user or organization.",K,T,me='Take a look at the <a href="https://github.com/huggingface/dataset-viewer/tree/main/services/worker#configuration" rel="nofollow">workers configuration</a> for a complete list of the environment variables if you’re interested in learning more.',N,_,Q,C,de="Once the workers complete a job, the results are stored - or <em>cached</em> - in a Mongo database. When a user makes a request with an endpoint like <code>/first-rows</code>, the dataset viewer retrieves the preprocessed response from the cache, and serves it to the user. This eliminates the time a user would’ve waited if the server hadn’t already completed the job and stored the response.",V,q,fe="As a result, users can get their requested information about a dataset (even large ones) nearly instantaneously!",X,k,Z,P,ee;return h=new te({props:{title:"Server infrastructure",local:"server-infrastructure",headingTag:"h1"}}),c=new te({props:{title:"Job queue",local:"job-queue",headingTag:"h2"}}),g=new te({props:{title:"Workers",local:"workers",headingTag:"h2"}}),_=new te({props:{title:"Cache",local:"cache",headingTag:"h2"}}),k=new Ce({props:{source:"https://github.com/huggingface/datasets-server/blob/main/docs/source/server.md"}}),{c(){u=i("meta"),I=a(),y=i("p"),S=a(),j(h.$$.fragment),W=a(),p=i("p"),p.innerHTML=ne,z=a(),m=i("ul"),m.innerHTML=ae,U=a(),d=i("p"),d.textContent=re,J=a(),f=i("p"),f.textContent=ie,O=a(),j(c.$$.fragment),F=a(),v=i("p"),v.textContent=oe,G=a(),b=i("p"),b.textContent=le,R=a(),w=i("ul"),w.innerHTML=ue,Y=a(),$=i("p"),$.innerHTML=he,B=a(),j(g.$$.fragment),D=a(),x=i("p"),x.textContent=pe,K=a(),T=i("p"),T.innerHTML=me,N=a(),j(_.$$.fragment),Q=a(),C=i("p"),C.innerHTML=de,V=a(),q=i("p"),q.textContent=fe,X=a(),j(k.$$.fragment),Z=a(),P=i("p"),this.h()},l(e){const t=Te("svelte-u9bgzb",document.head);u=o(t,"META",{name:!0,content:!0}),t.forEach(s),I=r(e),y=o(e,"P",{}),ce(y).forEach(s),S=r(e),M(h.$$.fragment,e),W=r(e),p=o(e,"P",{"data-svelte-h":!0}),l(p)!=="svelte-17a1vcw"&&(p.innerHTML=ne),z=r(e),m=o(e,"UL",{"data-svelte-h":!0}),l(m)!=="svelte-12qbi16"&&(m.innerHTML=ae),U=r(e),d=o(e,"P",{"data-svelte-h":!0}),l(d)!=="svelte-1uc899o"&&(d.textContent=re),J=r(e),f=o(e,"P",{"data-svelte-h":!0}),l(f)!=="svelte-19jmf8q"&&(f.textContent=ie),O=r(e),M(c.$$.fragment,e),F=r(e),v=o(e,"P",{"data-svelte-h":!0}),l(v)!=="svelte-1r0ezeb"&&(v.textContent=oe),G=r(e),b=o(e,"P",{"data-svelte-h":!0}),l(b)!=="svelte-wyypiy"&&(b.textContent=le),R=r(e),w=o(e,"UL",{"data-svelte-h":!0}),l(w)!=="svelte-n6lfh"&&(w.innerHTML=ue),Y=r(e),$=o(e,"P",{"data-svelte-h":!0}),l($)!=="svelte-1e44dmt"&&($.innerHTML=he),B=r(e),M(g.$$.fragment,e),D=r(e),x=o(e,"P",{"data-svelte-h":!0}),l(x)!=="svelte-7k57hi"&&(x.textContent=pe),K=r(e),T=o(e,"P",{"data-svelte-h":!0}),l(T)!=="svelte-w9oaen"&&(T.innerHTML=me),N=r(e),M(_.$$.fragment,e),Q=r(e),C=o(e,"P",{"data-svelte-h":!0}),l(C)!=="svelte-1qi5t6k"&&(C.innerHTML=de),V=r(e),q=o(e,"P",{"data-svelte-h":!0}),l(q)!=="svelte-l44lf6"&&(q.textContent=fe),X=r(e),M(k.$$.fragment,e),Z=r(e),P=o(e,"P",{}),ce(P).forEach(s),this.h()},h(){ve(u,"name","hf:doc:metadata"),ve(u,"content",ke)},m(e,t){_e(document.head,u),n(e,I,t),n(e,y,t),n(e,S,t),H(h,e,t),n(e,W,t),n(e,p,t),n(e,z,t),n(e,m,t),n(e,U,t),n(e,d,t),n(e,J,t),n(e,f,t),n(e,O,t),H(c,e,t),n(e,F,t),n(e,v,t),n(e,G,t),n(e,b,t),n(e,R,t),n(e,w,t),n(e,Y,t),n(e,$,t),n(e,B,t),H(g,e,t),n(e,D,t),n(e,x,t),n(e,K,t),n(e,T,t),n(e,N,t),H(_,e,t),n(e,Q,t),n(e,C,t),n(e,V,t),n(e,q,t),n(e,X,t),H(k,e,t),n(e,Z,t),n(e,P,t),ee=!0},p:we,i(e){ee||(L(h.$$.fragment,e),L(c.$$.fragment,e),L(g.$$.fragment,e),L(_.$$.fragment,e),L(k.$$.fragment,e),ee=!0)},o(e){A(h.$$.fragment,e),A(c.$$.fragment,e),A(g.$$.fragment,e),A(_.$$.fragment,e),A(k.$$.fragment,e),ee=!1},d(e){e&&(s(I),s(y),s(S),s(W),s(p),s(z),s(m),s(U),s(d),s(J),s(f),s(O),s(F),s(v),s(G),s(b),s(R),s(w),s(Y),s($),s(B),s(D),s(x),s(K),s(T),s(N),s(Q),s(C),s(V),s(q),s(X),s(Z),s(P)),s(u),E(h,e),E(c,e),E(g,e),E(_,e),E(k,e)}}}const ke='{"title":"Server infrastructure","local":"server-infrastructure","sections":[{"title":"Job queue","local":"job-queue","sections":[],"depth":2},{"title":"Workers","local":"workers","sections":[],"depth":2},{"title":"Cache","local":"cache","sections":[],"depth":2}],"depth":1}';function ye(se){return $e(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class He extends ge{constructor(u){super(),xe(this,u,ye,qe,be,{})}}export{He as component};
